import { InvalidChangeError } from '@crosslab/service-common';
import { bookExperiment } from './book.js';
import { finishExperiment } from './finish.js';
import { runExperiment } from './run.js';
export * from './book.js';
export * from './finish.js';
export * from './run.js';
export async function transitionExperiment(experimentModel, status, clients) {
    if (status === undefined) {
        if (experimentModel.status === 'created' ||
            experimentModel.status === 'booked' ||
            experimentModel.status === 'finished')
            status = experimentModel.status;
        else
            status = 'running';
    }
    switch (status) {
        case 'created':
            if (experimentModel.status !== 'created')
                throw new InvalidChangeError(`Cannot change status of experiment from "${experimentModel.status}" to "created"`, 400);
            break;
        case 'booked':
            return await bookExperiment(experimentModel);
        case 'running':
            return await runExperiment(experimentModel, clients);
        case 'finished':
            return await finishExperiment(experimentModel, clients);
    }
}
//# sourceMappingURL=index.js.map